'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-440dee10.js');
const index_esm_min = require('./index.esm.min-07bdb49e.js');
const index_esm_min$1 = require('./index.esm.min-d92c4a86.js');
const reduxStore_service = require('./redux-store.service-0338ee20.js');

const bpSdkTakeOverCss = "";

const BpSdkTakeOver = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.takeOverHandler = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over');
    customElements.whenDefined('bp-sdk-external-take-over').then(() => {
      this.useExternal = true;
    });
  }
  shouldRender() {
    return this.isFormLoaded && this.canTakeOver && !this.isOwner && !this.isCloned && !this.isLocked;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, shouldRender: this.shouldRender(), takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (this.shouldRender() && (index.h("div", { class: "bp-sdk-take-over__container" }, index.h("bp-sdk-take-over-button", { onClick: this.takeOverHandler }))));
  }
};
BpSdkTakeOver.style = bpSdkTakeOverCss;

const bpSdkTakeOverContainerCss = "";

const BpSdkTakeOverContainer = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      this.storeUnsubscribe && this.storeUnsubscribe();
      reduxStore_service.store.mapDispatchToProps(this, {
        cloneApplicationForm: index_esm_min.Cr,
      });
      this.storeUnsubscribe = reduxStore_service.store.mapStateToProps(this, this.mapStateToProps);
    };
    this.mapStateToProps = (state) => {
      return {
        appFormId: index_esm_min.ck(state),
        isLocked: index_esm_min.Xk(state),
        isCloned: index_esm_min.t2(state),
        canTakeOver: index_esm_min.g2(state, { permission: index_esm_min$1.S.TakeOver }),
        isOwner: index_esm_min.h2(state),
        isFormLoaded: index_esm_min.n2(state),
        config: index_esm_min.ud(state),
      };
    };
    this.takeOverHandler = () => {
      this.cloneApplicationForm({
        appFormId: this.appFormId,
        config: this.config,
      });
    };
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.appFormId = undefined;
    this.config = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over-container');
    customElements.whenDefined('bp-sdk-external-take-over-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (index.h("bp-sdk-external-take-over-container", { appFormId: this.appFormId, canTakeOver: this.canTakeOver, config: this.config, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (index.h("bp-sdk-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  get el() { return index.getElement(this); }
};
BpSdkTakeOverContainer.style = bpSdkTakeOverContainerCss;

exports.bp_sdk_take_over = BpSdkTakeOver;
exports.bp_sdk_take_over_container = BpSdkTakeOverContainer;
