import { store as sdkStore, setWebSocketConfig } from '@boldpenguin/sdk-redux';
import { h } from '@stencil/core';
export class BpSdkRoot {
  constructor() {
    this.completedAt = undefined;
    this.disableWebSocket = false;
    this.enableLifecycleEvents = false;
    this.disableToolbar = false;
    this.storeLoaded = false;
  }
  onDisabledWebSocket(disableWebSocket) {
    sdkStore.dispatch(setWebSocketConfig({ enableWebsocket: !disableWebSocket }));
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.onDisabledWebSocket(this.disableWebSocket);
  }
  render() {
    return (h("bp-sdk-setup-container", null, [!!this.enableLifecycleEvents && h("bp-sdk-custom-event-container", null), !this.disableToolbar && h("bp-sdk-interview-toolbar", null)], h("slot", null)));
  }
  static get is() { return "bp-sdk-root"; }
  static get properties() {
    return {
      "completedAt": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "Date",
          "resolved": "Date",
          "references": {
            "Date": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "disableWebSocket": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Disable web socket"
        },
        "attribute": "disable-web-socket",
        "reflect": false,
        "defaultValue": "false"
      },
      "enableLifecycleEvents": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Disable lifecycle events, false by default"
        },
        "attribute": "enable-lifecycle-events",
        "reflect": false,
        "defaultValue": "false"
      },
      "disableToolbar": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Disable toolbar"
        },
        "attribute": "disable-toolbar",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
  static get states() {
    return {
      "storeLoaded": {}
    };
  }
  static get watchers() {
    return [{
        "propName": "disableWebSocket",
        "methodName": "onDisabledWebSocket"
      }];
  }
}
