import { r as registerInstance, c as createEvent, a as getElement } from './index-8298fa0c.js';
import { e as Mk } from './index.esm.min-06b27be7.js';
import { j as je } from './index.esm.min-84479337.js';
import { s as store } from './redux-store.service-ce20a3ff.js';

const SDK_ERRORS = [new je().name];
const BpSdkErrorEventContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.sdkError = createEvent(this, "sdkError", 7);
    this.handleError = (ev) => {
      try {
        const { error } = ev;
        if (SDK_ERRORS.includes(error === null || error === void 0 ? void 0 : error.name)) {
          // Emit DOM event
          this.sdkError.emit({ error });
          // Send error to console if debug flag is on
          this.isDebug && console.error(error);
          // Send to error handler function if it's provided
          this.errorHandler && this.errorHandler(error);
        }
      }
      catch (e) {
        // Swallow errors here, if we can't capture the error successfully just do nothing
      }
    };
    this.handleSubscriptions = () => {
      this.storeUnsubscribe && this.storeUnsubscribe();
      this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
    };
    this.mapStateToProps = (state) => {
      return {
        isDebug: Mk(state),
      };
    };
    this.errorHandler = undefined;
    this.isDebug = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    window.addEventListener('error', this.handleError);
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return null;
  }
  get el() { return getElement(this); }
};

export { BpSdkErrorEventContainer as bp_sdk_error_event_container };
