import { r as registerInstance, h, a as getElement } from './index-8298fa0c.js';
import { s as s2 } from './index.esm.min-06b27be7.js';
import { s as store } from './redux-store.service-ce20a3ff.js';

const BpSdkMessageContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      this.storeUnsubscribe && this.storeUnsubscribe();
      this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
    };
    this.mapStateToProps = (state) => {
      return {
        // Legacy messages target the application form and are displayed here. Non-legacy messages can be attached to
        // components other than the application form and will be handled elsewhere.
        messages: s2(state),
      };
    };
    this.messages = undefined;
    this.useExternal = false;
    this.lastMessage = undefined;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-message-container');
    customElements.whenDefined('bp-sdk-external-message-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  handleMessagesUpdate(messages) {
    this.lastMessage = messages[this.messages.length - 1];
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  componentWillUpdate() {
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-message-container", { messages: this.messages });
  }
  renderInternal() {
    return this.lastMessage && h("bp-sdk-message", { message: this.lastMessage });
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "messages": ["handleMessagesUpdate"]
  }; }
};

export { BpSdkMessageContainer as bp_sdk_message_container };
