import { r as registerInstance, h } from './index-8298fa0c.js';
import { O as OD } from './index.esm.min-06b27be7.js';
import { s as store } from './redux-store.service-ce20a3ff.js';

const bpSdkNotificationsContainerCss = "";

const BpSdkNotificationsContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      this.storeUnsubscribe && this.storeUnsubscribe();
      store.mapDispatchToProps(this, {
        removeNotification: OD,
      });
      this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
    };
    this.mapStateToProps = (state) => {
      return {
        notifications: state.notifications,
      };
    };
    this.handleRemoveNotification = (notification) => {
      this.removeNotification(notification);
    };
    this.notifications = undefined;
    this.useExternal = false;
  }
  resetState() {
    this.notifications = [];
  }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-notifications-container');
    customElements.whenDefined('bp-sdk-external-notifications-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-notifications-container", { notifications: this.notifications });
  }
  renderInternal() {
    if (this.notifications.length > 0) {
      return (h("div", { class: "bp-sdk-notifications-container__container" }, this.notifications.map((notification) => this.renderNotifications(notification))));
    }
  }
  renderNotifications(notification) {
    return h("bp-sdk-notification", { notification: notification, removeNotification: this.handleRemoveNotification });
  }
};
BpSdkNotificationsContainer.style = bpSdkNotificationsContainerCss;

export { BpSdkNotificationsContainer as bp_sdk_notifications_container };
