import { r as registerInstance, h } from './index-8298fa0c.js';
import { F as Fh } from './index.esm.min-d911aea2.js';

const bpSdkQuoteRequestButtonCss = "";

const BpSdkQuoteRequestButton = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.text = '';
    this.buttonId = Fh(8);
    this.buttonDisabled = false;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-quote-request-button');
    customElements.whenDefined('bp-sdk-external-quote-request-button').then(() => {
      this.useExternal = true;
    });
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return h("bp-sdk-external-quote-request-button", { buttonId: this.buttonId, buttonDisabled: this.buttonDisabled, text: this.text });
  }
  renderInternal() {
    return (h("bp-sdk-button", { class: "bp-sdk-quote-request-button__container", text: this.text, buttonId: this.buttonId, buttonDisabled: this.buttonDisabled }));
  }
};
BpSdkQuoteRequestButton.style = bpSdkQuoteRequestButtonCss;

export { BpSdkQuoteRequestButton as bp_sdk_quote_request_button };
