import { r as registerInstance, h, a as getElement } from './index-8298fa0c.js';
import { X as Cr, g as ck, Y as Xk, _ as t2, j as g2, i as h2, C as n2, u as ud } from './index.esm.min-06b27be7.js';
import { S } from './index.esm.min-84479337.js';
import { s as store } from './redux-store.service-ce20a3ff.js';

const bpSdkTakeOverCss = "";

const BpSdkTakeOver = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.takeOverHandler = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over');
    customElements.whenDefined('bp-sdk-external-take-over').then(() => {
      this.useExternal = true;
    });
  }
  shouldRender() {
    return this.isFormLoaded && this.canTakeOver && !this.isOwner && !this.isCloned && !this.isLocked;
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, shouldRender: this.shouldRender(), takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (this.shouldRender() && (h("div", { class: "bp-sdk-take-over__container" }, h("bp-sdk-take-over-button", { onClick: this.takeOverHandler }))));
  }
};
BpSdkTakeOver.style = bpSdkTakeOverCss;

const bpSdkTakeOverContainerCss = "";

const BpSdkTakeOverContainer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.handleSubscriptions = () => {
      this.storeUnsubscribe && this.storeUnsubscribe();
      store.mapDispatchToProps(this, {
        cloneApplicationForm: Cr,
      });
      this.storeUnsubscribe = store.mapStateToProps(this, this.mapStateToProps);
    };
    this.mapStateToProps = (state) => {
      return {
        appFormId: ck(state),
        isLocked: Xk(state),
        isCloned: t2(state),
        canTakeOver: g2(state, { permission: S.TakeOver }),
        isOwner: h2(state),
        isFormLoaded: n2(state),
        config: ud(state),
      };
    };
    this.takeOverHandler = () => {
      this.cloneApplicationForm({
        appFormId: this.appFormId,
        config: this.config,
      });
    };
    this.isLocked = undefined;
    this.isCloned = undefined;
    this.canTakeOver = undefined;
    this.isOwner = undefined;
    this.isFormLoaded = undefined;
    this.appFormId = undefined;
    this.config = undefined;
    this.useExternal = false;
  }
  resetState() { }
  connectedCallback() {
    this.resetState();
    this.handleSubscriptions();
  }
  componentWillLoad() {
    this.useExternal = !!customElements.get('bp-sdk-external-take-over-container');
    customElements.whenDefined('bp-sdk-external-take-over-container').then(() => {
      this.useExternal = true;
    });
    this.handleSubscriptions();
  }
  disconnectedCallback() {
    this.storeUnsubscribe && this.storeUnsubscribe();
  }
  render() {
    return [this.useExternal && this.renderExternal(), !this.useExternal && this.renderInternal()];
  }
  renderExternal() {
    return (h("bp-sdk-external-take-over-container", { appFormId: this.appFormId, canTakeOver: this.canTakeOver, config: this.config, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  renderInternal() {
    return (h("bp-sdk-take-over", { canTakeOver: this.canTakeOver, isCloned: this.isCloned, isLocked: this.isLocked, isOwner: this.isOwner, isFormLoaded: this.isFormLoaded, takeOverHandler: this.takeOverHandler }));
  }
  get el() { return getElement(this); }
};
BpSdkTakeOverContainer.style = bpSdkTakeOverContainerCss;

export { BpSdkTakeOver as bp_sdk_take_over, BpSdkTakeOverContainer as bp_sdk_take_over_container };
